#include <Standalone.h>
#include "../Include/endianutils.h"
#include "../Include/palmos5.h"

#include "GSI_Res.h"

#define RESID RESID_GsiSetShiftState

#define SWAP32( x ) ( ( ( x ) >> 24 ) | ( ( ( x ) & 0x00FF0000l ) >> 8 ) | ( ( ( x ) & 0x0000FF00l ) << 8 ) |  ( ( x ) << 24 ) )

STANDALONE_CODE_RESOURCE_TYPESTR_ID("armc", RESID);

typedef void (*pfnGsiSetShiftState)( const UInt16 lockFlags, const UInt16 tempShift );

void MyGsiSetShiftState( const UInt16 lockFlags, const UInt16 tempShift )
{
    pfnGsiSetShiftState oldTrap;
    UInt32 GsiState;

    FtrGet(MY_CRID, RESID, (UInt32*) &oldTrap );

	if (tempShift == grfTempShiftPunctuation)
		GsiState = gsiShiftPunctuation;

	else if (tempShift == grfTempShiftExtended)
		GsiState = gsiShiftExtended;

	else if (tempShift == grfTempShiftUpper)
		GsiState = gsiShiftUpper;

	else if (tempShift == grfTempShiftLower)
		GsiState = gsiShiftLower;

	else if (lockFlags & glfNumLock)
		GsiState = gsiNumLock;

	else if (lockFlags & glfCapsLock)
		GsiState = gsiCapsLock;

	else
		GsiState = gsiShiftNone;

     FtrSet( MY_CRID, FTR_GSI_STATE, GsiState );

     if ( GsiEnabled() ) 
         GsiEnable( true );
}




